#include <Arduino.h>

#ifndef PGM
#define PGM     __attribute__((section(".progmem.data")))
#endif

#define DEBUG   1


#define DSP_I2C                  0x38
#define IF_I2C                   0xC2

#define DSP_FM_LEVEL             0x030449
#define DSP_AM_LEVEL             0x03004F
#define DSP_ST_19kHz             0x03044D

#define DSP_VOLUME_SCALER        0x0D106C
#define DSP_VOLUME_SCALER2       0x0D12E4
#define DSP_LOUDNESS_COMP        0x0D106B
#define DSP_MUTE                 0x0D1072

#define TDSP1_X_CIBW_1_FirCtl    0x010191
#define TDSP1_X_CIBW_1_FirCtlFix 0x010192
#define TDSP1_X_CIBW_1_pFirCtl   0x010193
#define TDSP1_X_CIBW_4_FirCtl    0x010194
#define TDSP1_X_CIBW_4_FirCtlFix 0x010195
#define TDSP1_X_CIBW_4_pFirCtl   0x010196



// Pins
#define RST_PIN       A3
#define SCL_PIN       A5
#define SDA_PIN       A4
#define RDS_PIN       A2

#define SH1A_PIN       2
#define SH1B_PIN       7
#define SH2A_PIN       3
#define SH2B_PIN      A1
#define KS1_PIN       A0

#define LCD_RS_PIN     4
#define LCD_E_PIN     12
#define LCD_BKLT_PIN   6

#define LED_PIN       13


// Modes
#define NUM_MODES 3
#define MODE_AM   0
#define MODE_FM   1
#define MODE_AUX  2


// Volume
#define MIN_VOL     0
#define MAX_VOL    63


// Tune types
#define NUM_TYPES   5

#define TYPE_FREQ   0
#define TYPE_SEEK   1
#define TYPE_CH     2
#define TYPE_SCAN   3
#define TYPE_ANY    4
#define TYPE_SCSV   5  // Special tune type for scan & save


// Bands
#define NUM_BANDS   9

#define BAND_LW     0
#define BAND_MW     1
#define BAND_SW     2
#define BAND_SH     3
#define BAND_FL     4
#define BAND_FM     5
#define BAND_AL     6
#define BAND_AB     7
#define BAND_VH     8


// Steps
#define NUM_STEPS  3   // Step values for each band


// Deemphasis
#define DEEMPHOFF 0
#define DEEMPH50  1
#define DEEMPH75  2


// Need auto sync to NV memory, bits definition
#define NEEDSYNC_BAND       0x0001
#define NEEDSYNC_VOL        0x0002
#define NEEDSYNC_MODE       0x0004
#define NEEDSYNC_RFMODE     0x0008
#define NEEDSYNC_TUNE       0x0010
#define NEEDSYNC_STEPIDX    0x0020
#define NEEDSYNC_AMFILTER   0x0040
#define NEEDSYNC_FMFILTER   0x0080
#define NEEDSYNC_MISC1      0x0100


#define TIMER_INTERVAL    500   // Check signal level and 19kHz subcarrier every TIMER_INTERVAL, ms
#define TIMER_ALTDISP    3000   // Must bigger than TIMER_INTERVAL, ms
#define TIMER_AUTOSYNC   5000   // Must bigger than TIMER_INTERVAL, ms
